package vn.teko.apollo.apollo_flutter

import androidx.annotation.NonNull
import io.flutter.embedding.engine.plugins.FlutterPlugin
import vn.teko.apollo.terra.TerraApollo
import vn.teko.terra.core.android.terra.TerraApp

/** ApolloFlutterPlugin */
class ApolloFlutterPlugin : FlutterPlugin, ApolloFlutter.FlutterApolloApi {

    override fun onAttachedToEngine(flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
        ApolloFlutter.FlutterApolloApi.setup(flutterPluginBinding.binaryMessenger, this)
    }

    override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
        ApolloFlutter.FlutterApolloApi.setup(binding.binaryMessenger, null)
    }

    override fun getInstance(appName: String): ApolloFlutter.GetInstanceResult {
        val resultStatus = ApolloFlutter.GetInstanceResult()
        try {
            val apollo = TerraApollo.getInstance(TerraApp.getInstance(appName))
            resultStatus.isSuccess = true
            resultStatus.colorTheme = apollo.getConfig().toFlutterColorTheme()
        } catch (error: Throwable) {
            resultStatus.isSuccess = false
            resultStatus.error = error.message
        }

        return resultStatus
    }
}