package vn.teko.apollo.apollo_flutter

import vn.teko.apollo.config.ApolloColorPaletteConfig
import vn.teko.apollo.config.ApolloColorThemeConfig
import vn.teko.apollo.config.ApolloNeutralColorConfig

internal fun ApolloColorThemeConfig.toFlutterColorTheme() =
    ApolloFlutter.FlutterColorTheme().apply {
        primary = primaryColor.toFlutterColorSet()
        link = linkColor.toFlutterColorSet()
        pending = pendingColor.toFlutterColorSet()
        success = successColor.toFlutterColorSet()
        error = errorColor.toFlutterColorSet()
        neutral = neutralColor.toFlutterNeutralColorSet()
    }

private fun ApolloColorPaletteConfig.toFlutterColorSet() =
    ApolloFlutter.FlutterColorSet.Builder()
        .setColor50(color50)
        .setColor100(color100)
        .setColor200(color200)
        .setColor500(color500)
        .setColor600(color600)
        .setColor700(color700)
        .build()

private fun ApolloNeutralColorConfig.toFlutterNeutralColorSet() =
    ApolloFlutter.FlutterNeutralColorSet().apply {
        white = whiteColor
        tableHeader = tableHeaderColor
        background = backgroundColor
        divider = dividerColor
        disable = disableColor
        border = borderColor
        placeholder = placeholderColor
        secondaryText = secondaryTextColor
        primaryText = primaryTextColor
        titleText = titleTextColor
    }