import Flutter
import UIKit
import ApolloTheme
import Terra

public class SwiftApolloFlutterPlugin: NSObject, FlutterPlugin, FlutterApolloApi {
    
    public static func register(with registrar: FlutterPluginRegistrar) {
        let flutterApolloApi = SwiftApolloFlutterPlugin()
        FlutterApolloApiSetup(registrar.messenger(), flutterApolloApi)
    }

    public func getInstanceAppName(_ appName: String, error: AutoreleasingUnsafeMutablePointer<FlutterError?>) -> GetInstanceResult? {
        let resultStatus = GetInstanceResult()
        do {
            let terraApp = try TerraApp.getInstance(appName: appName)
            TerraTheme.configureWith(app: terraApp)
            resultStatus.isSuccess = true
            resultStatus.colorTheme = TerraTheme.getInstance(by: appName)?.getConfig()?.toFlutterColorTheme()
        } catch {
            resultStatus.isSuccess = false
            resultStatus.error = error.localizedDescription
        }
        
        return resultStatus
    }
}
