import 'package:flutter/cupertino.dart';

class ApolloTheme {
  ApolloColorTheme colors;

  ApolloTheme({required this.colors});
}

class ApolloColorTheme {
  ApolloColorSet primary;
  ApolloColorSet error;
  ApolloColorSet pending;
  ApolloColorSet success;
  ApolloColorSet link;
  ApolloNeutralColorSet neutral;

  ApolloColorTheme({
    required this.primary,
    required this.error,
    required this.pending,
    required this.success,
    required this.link,
    required this.neutral,
  });
}

class ApolloColorSet {
  Color color50;
  Color color100;
  Color color200;
  Color color500;
  Color color600;
  Color color700;

  ApolloColorSet({
    required this.color50,
    required this.color100,
    required this.color200,
    required this.color500,
    required this.color600,
    required this.color700,
  });
}

class ApolloNeutralColorSet {
  Color white;
  Color tableHeader;
  Color background;
  Color divider;
  Color disable;
  Color border;
  Color placeholder;
  Color secondaryText;
  Color primaryText;
  Color titleText;

  ApolloNeutralColorSet({
    required this.white,
    required this.tableHeader,
    required this.background,
    required this.divider,
    required this.disable,
    required this.border,
    required this.placeholder,
    required this.secondaryText,
    required this.primaryText,
    required this.titleText,
  });
}
